unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    MemLpchText: TMemo;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    EditTabLength: TEdit;
    EditLeftMargin: TEdit;
    EditRightMargin: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Memo2: TMemo;
    Label10: TLabel;
    Label11: TLabel;
    Label1: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    LblP4Left: TLabel;
    LblP4Top: TLabel;
    LblP4Right: TLabel;
    LblP4Bottom: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    LblResultP4Left: TLabel;
    LblResultP4Top: TLabel;
    LblResultP4Right: TLabel;
    LblResultP4Bottom: TLabel;
    Label21: TLabel;
    LblResultUiLengthDrawn: TLabel;
    Label2: TLabel;
    LblResultDrawTextEx: TLabel;
    Label24: TLabel;
    Label3: TLabel;
    Label25: TLabel;
    LblFontName: TLabel;
    LblFontSize: TLabel;
    LblFontStyle: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    FontDialog1: TFontDialog;
    LbDTFormat: TListBox;
    MemGetLastError: TMemo;
    Label22: TLabel;
    MemHint: TMemo;
    Button1: TButton;
    Button2: TButton;
    procedure EditTabLengthKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Label25Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure LbDTFormatClick(Sender: TObject);
    procedure Label21Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure EditTabLengthChange(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    ClipBrd, Info;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  SpinEdit
//  http://www.comrade.co.jp/ftp/pg1/manual/VKeys.htm
procedure TForm1.EditTabLengthKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
    Edit: TEdit;
    Diff: Integer;
begin
    Edit := TEdit(Sender);

    case Key of
        VK_PRIOR: Diff := + 10;
        VK_NEXT : Diff := - 10;
        VK_UP   : Diff := +  1;
        VK_DOWN : Diff := -  1;
        VK_HOME : Diff := - Edit.Tag;
        else      Diff := 0;
    end;

    Edit.Tag := StrToIntDef(Edit.Text, 0) + Diff;
    Edit.Text := IntToStr(Edit.Tag);
    Edit.SelectAll();
end;

//-----------------------------------------------------------------------------
const
    //PARAM_ARRAY: array[0..23] of Cardinal
    PARAM_ARRAY: array[0..22] of Cardinal
    = (
        DT_BOTTOM
        ,DT_CALCRECT
        ,DT_CENTER
        ,DT_EDITCONTROL
        ,DT_END_ELLIPSIS
        ,DT_EXPANDTABS
        ,DT_EXTERNALLEADING
        ,DT_HIDEPREFIX
        ,DT_INTERNAL
        ,DT_LEFT
        ,DT_MODIFYSTRING
        ,DT_NOCLIP
        //,DT_NOFULLWIDTHCHARBREAK
        ,DT_NOPREFIX
        ,DT_PATH_ELLIPSIS
        ,DT_PREFIXONLY
        ,DT_RIGHT
        ,DT_RTLREADING
        ,DT_SINGLELINE
        ,DT_TABSTOP
        ,DT_TOP
        ,DT_VCENTER
        ,DT_WORDBREAK
        ,DT_WORD_ELLIPSIS
    );

const
    PARAM_ARRAY_TEXT: array[0..22] of String
    = (
        '͈͂̉Ɋ񂹂BDT_SINGLELINEƈꏏɎw肷B'
        ,'`͈͂vZāAp4㏑BDraw TextEx͍߂`悵ȂB'
        ,'ʒu𒆊'
        ,'s\Rg[̂悤ɕ`悷Bɕς̕ҏWRg[Ɠ@ŌvZꕔȂs͕`悵ȂB'
        ,'͂ݏou...v\(Ō̒P͏)BDT_MODIFYSTRINGw肳ĂȂƂ͕ύXȂB'
        ,'^uWJBK̃^u 8'
        ,'tHg̊OfBOs̍Ɋ܂߂(ʏ͊܂܂Ȃ)B'
        ,'Windows 2000/XP: ԍŏ́̕𖳎(?)B̑B'
        ,'eLXg̃gbNXvZƂɃVXetHggpB'
        ,'񂹁B'
        ,'\CBDT_END_ELLIPSIS  DT_PATH_ELLIPSIS w肳ĂȂΈӖȂB'
        ,'͂ݏoNbvȂBƍB'
        //DT_NOFULLWIDTHCHARBREAK Windows 98/Me, Windows 2000/XP: Prevents a line break at a DBCS (double-wide character string), so that the line-breaking rule is equivalent to SBCS strings. For example, this can be used in Korean windows, for more readability of icon labels. This value has no effect unless DT_WORDBREAK is specified.
        ,'̈ƕύXB悭킩ȂB'
        ,'t@CpXt@Cc悤ɏȗ\B'
        ,'Windows 2000/XP: ̉`(H)'
        ,'E񂹁B'
        ,'foCXReLXgHebrewArabictHgIĂƂE獶Ɍĕ`悷B'
        ,'1s\BsłsςȂB'
        ,'^uǂɂB'
        ,'Ɋ񂹂B'
        ,'cɒ񂹂BDT_SINGLELINEƈꏏɎw肷B'
        ,'PƉsŐ܂ԂB'
        ,'͂ݏoPāu...v\B'
    );

//-----------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
    MoveToScreenCenter(Self);
end;

//-----------------------------------------------------------------------------
//  ݒύX
procedure TForm1.LbDTFormatClick(Sender: TObject);
begin
    if (LbDTFormat.ItemIndex <> -1) then
    begin
        MemHint.Text := PARAM_ARRAY_TEXT[LbDTFormat.ItemIndex];
    end;
    PaintBox1.Repaint();
end;

//-----------------------------------------------------------------------------
//  tHgύX
procedure TForm1.Label25Click(Sender: TObject);
begin
    FontDialog1.Font.Assign(PaintBox1.Font);
    if (FontDialog1.Execute()) then
    begin
        PaintBox1.Font.Assign(FontDialog1.Font);
        PaintBox1.Repaint();
    end;
end;

//-----------------------------------------------------------------------------
//  gύX
procedure TForm1.EditTabLengthChange(Sender: TObject);
begin
    PaintBox1.Repaint();
end;

//-----------------------------------------------------------------------------
//  `v
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    DrawFormat: Cardinal;
    DrawParams: TDrawTextParams;
    R: TRect;
    i: integer;
    Res: Integer;
    Temp: String;
begin
    //---------------------------------------------------------------
    //  `͈
    R := PaintBox1.ClientRect;

    //  ŏɓhԂĂ
    PaintBox1.Canvas.FillRect(R);

    //---------------------------------------------------------------
    //  `̈\
    LblP4Left.Caption   := Format('%3d', [R.Left]);
    LblP4Top.Caption    := Format('%3d', [R.Top]);
    LblP4Right.Caption  := Format('%3d', [R.Right]);
    LblP4Bottom.Caption := Format('%3d', [R.Bottom]);

    //  tHg\
    LblFontName.Caption := PaintBox1.Canvas.Font.Name;
    LblFontSize.Caption := Format('%d Point', [PaintBox1.Canvas.Font.Size]);
    Temp := '';
    if (fsBold in PaintBox1.Canvas.Font.Style) then Temp := Temp + 'bsBold,';
    if (fsItalic in PaintBox1.Canvas.Font.Style) then Temp := Temp + 'fsItalic,';
    if (fsUnderline in PaintBox1.Canvas.Font.Style) then Temp := Temp + 'fsUnderline,';
    if (fsStrikeOut in PaintBox1.Canvas.Font.Style) then Temp := Temp + 'fsStrikeOut,';
    if (Temp <> '') then Temp := Copy(Temp, 1, Length(Temp) - 1);
    Temp := '[' + Temp + ']';
    LblFontStyle.Caption := Temp;

    //---------------------------------------------------------------
    //  
    DrawFormat := 0;

    //  `FbNĂeŏݒ
    for i := 0 to LbDTFormat.Items.Count - 1 do
    begin
        if LbDTFormat.Selected[i] then
        begin
            DrawFormat := DrawFormat or PARAM_ARRAY[i];
        end;
    end;

    //---------------------------------------------------------------
    //  g
    FillChar(DrawParams, SizeOf(DrawParams), 0);
    DrawParams.cbSize := SizeOf(DrawParams);

    //  ^u
    DrawParams.iTabLength := EditTabLength.Tag;

    //  }[W
    DrawParams.iLeftMargin := EditLeftMargin.Tag;

    //  E}[W
    DrawParams.iRightMargin := EditRightMargin.Tag;

    //---------------------------------------------------------------
    //  s
    Res := DrawTextEx(
        PaintBox1.Canvas.Handle,
        PChar(MemLpchText.Text),
        -1,
        R,
        DrawFormat,
        @DrawParams);

    //---------------------------------------------------------------
    //  sʂ\
    LblResultDrawTextEx.Caption := IntToStr(Res);

    MemGetLastError.Text := SysErrorMessage(GetLastError());

    //  `̈̌ʂ\
    LblResultP4Left.Caption   := Format('%3d', [R.Left]);
    LblResultP4Top.Caption    := Format('%3d', [R.Top]);
    LblResultP4Right.Caption  := Format('%3d', [R.Right]);
    LblResultP4Bottom.Caption := Format('%3d', [R.Bottom]);

    //  ꂽ\
    LblResultUiLengthDrawn.Caption := IntToStr(DrawParams.uiLengthDrawn);
end;

//-----------------------------------------------------------------------------
//  qg\
procedure TForm1.Label21Click(Sender: TObject);
begin
    MemHint.Text := TLabel(Sender).Hint;
end;

//-----------------------------------------------------------------------------
//  R[h
procedure TForm1.Button1Click(Sender: TObject);
var
    StrBuf: TStringList;
    StrBuf2: TStringList;
    i: Integer;
    Temp: String;
begin
    StrBuf := nil;
    StrBuf2 := nil;
    try
        StrBuf := TStringList.Create();
        StrBuf2 := TStringList.Create();

        StrBuf.Add('procedure TForm1.Button1Click(Sender: TObject);');
        StrBuf.Add('var');
        StrBuf.Add('    R: TRect;                       //  `̈');
        StrBuf.Add('    DrawFormat: Cardinal;           //  ');
        StrBuf.Add('    DrawParams: TDrawTextParams;    //  g');
        StrBuf.Add('    ResDrawTextEx: Integer;         //  ߂l');
        StrBuf.Add('begin');
        StrBuf.Add('    //  `̈挈(Ƃ肠tH[)');
        StrBuf.Add('    R := Self.ClientRect;');
        StrBuf.Add('    //  ݒ');
        if (LbDTFormat.SelCount = 0) then
        begin
            StrBuf.Add('    DrawFormat := 0;');
        end
        else
        begin
            for i := 0 to LbDTFormat.Items.Count - 1 do
            begin
                if (LbDTFormat.Selected[i]) then
                begin
                    StrBuf2.Add(LbDTFormat.Items[i]);
                end;
            end;
            StrBuf2.Delimiter := '+';
            Temp := StrBuf2.DelimitedText;
            Temp := StringReplace(Temp, '+', ' or ', [rfReplaceAll]);
            StrBuf.Add('    DrawFormat := ' + Temp + ';');
        end;

        StrBuf.Add('    //  gݒ');
        StrBuf.Add('    FillChar(DrawParams, SizeOf(DrawParams), 0);');
        StrBuf.Add('    DrawParams.cbSize := SizeOf(DrawParams);');
        StrBuf.Add('    DrawParams.iTabLength   := ' + IntToStr(EditTabLength.Tag) + ';');
        StrBuf.Add('    DrawParams.iLeftMargin  := ' + IntToStr(EditLeftMargin.Tag) + ';');
        StrBuf.Add('    DrawParams.iRightMargin := ' + IntToStr(EditRightMargin.Tag) + ';');
        StrBuf.Add('    //  s');
        StrBuf.Add('    ResDrawTextEx := DrawTextEx(');
        StrBuf.Add('                        Self.Canvas.Handle,     //  Ƃ肠tH[');
        StrBuf.Add('                        PChar(ParamStr(0)),     //  Ƃ肠EXEpX');
        StrBuf.Add('                        -1,                     //  Œŏ\');
        StrBuf.Add('                        R,                      //  Kϐ');
        StrBuf.Add('                        DrawFormat,             //  ');
        StrBuf.Add('                        @DrawParams             //  g');
        StrBuf.Add('                        );');
        StrBuf.Add('    ShowMessage(SysErrorMessage(GetLastError()));');
        StrBuf.Add('end;');

        Clipboard.AsText := StrBuf.Text;

        ShowMessage('Rs[܂');
    finally
        StrBuf.Free();
        StrBuf2.Free();
    end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    OpenInfoForm();
end;

end.

